<template>
  <div
    class="ob-card"
    :class="{ '--state-empty': isEmpty }"
    :data-qa="dataQa"
    @click="$emit('click')"
  >
    <div class="ob-card__row ob-card__row_multirow">
      <div class="ob-card__title">
        <div
          class="ob-card__title-icon"
          :class="{ '--state-empty': isEmpty }"
        >
          <img
            width="18"
            height="43"
            :src="itemImage"
          >
        </div>
        <div class="ob-card__title-text">
          <div>
            {{ title }}
          </div>
        </div>
      </div>
      <div
        v-if="date || time"
        class="ob-card__date"
      >
        <!-- date -->
        <div
          v-if="date"
          class="ob-card__date-calendar ob-card__date-child"
          :class="{ 'ob-card__date-error': handledError.date }"
        >
          <template
            v-if="handledError.date"
          >
            <ob-tooltip
              :content="handledError.date"
              position="top-start"
              type="error"
            >
              <i class="icon calendar" />
            </ob-tooltip>
          </template>
          <i
            v-else
            class="icon calendar"
          />
          {{ date }}
        </div>

        <!-- time -->
        <div
          v-if="time"
          class="ob-card__date-child"
          :class="{ 'ob-card__date-error': handledError.time }"
        >
          <template
            v-if="handledError.time"
          >
            <ob-tooltip
              :content="handledError.time"
              position="top-start"
              type="error"
            >
              <i class="icon clock" />
            </ob-tooltip>
          </template>
          <i
            v-else
            class="icon clock"
          />
          {{ time }}
        </div>
      </div>
    </div>

    <!-- location -->
    <div
      v-if="location"
      class="ob-card__row ob-card__row_multirow"
    >
      <div
        v-if="locationLabel"
        class="ob-card__location ob-card__location-label"
      >
        {{ locationLabel }}
      </div>
      <div
        class="ob-card__location ob-card__location-text"
        :class="{ error: handledError.location }"
      >
        <template
          v-if="handledError.location"
        >
          <ob-tooltip
            :content="handledError.location"
            position="top-start"
            type="error"
          >
            <i class="icon pin" />
          </ob-tooltip>
          {{ location }}
        </template>
        <template
          v-else
        >
          <i class="icon pin" />
          {{ location }}
        </template>
      </div>
    </div>

    <!-- locationDoc -->
    <div
      v-if="locationDoc"
      class="ob-card__row ob-card__row_multirow"
    >
      <div
        v-if="locationDocLabel"
        class="ob-card__location ob-card__location-label"
      >
        {{ locationDocLabel }}
      </div>
      <div
        class="ob-card__location ob-card__location-text"
        :class="{ error: handledError.locationDoc }"
      >
        <template
          v-if="handledError.locationDoc"
        >
          <ob-tooltip
            :content="handledError.locationDoc"
            position="top"
            type="error"
          >
            <i class="icon role-agent" />
          </ob-tooltip>
          {{ locationDoc }}
        </template>
        <template
          v-else
        >
          <i class="icon role-agent" />
          {{ locationDoc }}
        </template>
      </div>
    </div>

    <div
      v-if="companies.length"
      class="ob-card__row ob-card__row_multirow"
    >
      <div class="ob-card__companies-title-container">
        <div class="ob-card__companies-title">
          Груз распределен от
        </div>
      </div>
      <div
        v-for="(item, index) in companies"
        :key="`company_${index}`"
        class="ob-card__companies-item"
      >
        <div>
          {{ item.name }}
        </div>
        <div class="ob-card__companies-item-counter">
          {{ item.count }}
          <i class="icon home" />
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import ObTooltip from '../obTooltip'

export default {
  components: { ObTooltip },
  props: {
    type: {
      type: String,
      default: 'down',
      validator: value => ['down', 'up'].includes(value)
    },
    title: {
      type: String,
      default: ''
    },
    date: {
      type: String,
      default: ''
    },
    time: {
      type: String,
      default: ''
    },
    location: {
      type: String,
      default: ''
    },
    locationLabel: {
      type: String,
      default: ''
    },
    locationDoc: {
      type: String,
      default: ''
    },
    locationDocLabel: {
      type: String,
      default: ''
    },
    companies: {
      type: Array,
      default: () => []
    },
    error: {
      type: Object,
      default: () => {}
    },
    dataQa: {
      type: String
    }
  },
  computed: {
    handledError () {
      const error = {
        date: '',
        time: '',
        location: '',
        locationDoc: ''
      }

      return Object.assign(error, this.error)
    },
    itemImage () {
      const fileName = this.type === 'down' ? 'logchain-zagr' : 'logchain-razgr'
      return require(`./${fileName}.svg`)
    },
    isEmpty () {
      return !this.date && !this.time
    }
  }
}

</script>

<style lang="scss" scoped>
@import "../../static/css/variables";
@import "../../static/css/mixins";

@mixin error() {
  position: relative;
  color: $color-error;

  & i {
    position: static;

    &::before {
      color: $color-error;
    }

    &::after {
      content: "";
      position: absolute;
      top: 0;
      right: 0;
      bottom: 0;
      left: 0;
    }
  }
}

.ob-card {
  display: flex;
  flex-direction: column;
  padding: 10px 19px;
  width: 100%;
  border: 1px solid $lavender;
  border-radius: 3px;
  background-color: $background-white;
  box-shadow: 0px 4px 10px rgba($cobalt, 0.06),
              0px 0px 12px rgba($cobalt, 0.04),
              0px 0px 2px rgba($cobalt, 0.15);
  cursor: pointer;

  & i {
    color: $cobalt;
  }

  &__row {
    display: flex;
    margin-top: 19px;
    @include font-mixin(12px, 14px, 400, $cobalt-black, 0.4px);

    &:first-child {
      margin-top: 0;
    }
    &_multirow {
      flex-direction: column;
    }
    i {
      font-size: 15px;
    }
    &_with-border {
      border-top: 1px solid $very-pale-blue;
    }
  }

  &__title {
    display: flex;
    &-icon {
      margin-right: 8px;
      &.empty {
        margin-right: 20px;
      }
    }
    &-text {
      display: flex;
      justify-content: center;
      flex-direction: column;
      @include font-mixin(16px, 20px, 400, $cobalt-black, 0.2px);
    }
  }

  &__date {
    display: flex;
    margin-top: 10px;
    &-child {
      display: flex;
    }
    &-calendar {
      margin-right: 27px;
      i {
        font-size: 14px;
      }
    }
    &-time {
      i {
        font-size: 15px;
      }
    }
    &-error {
      @include error();
    }
    i {
      margin-right: 10px;
    }
  }

  &__location {
    display: flex;
    @include font-mixin(12px, 14px, 400, $cobalt-black, 0.2px);

    &.error {
      @include error();
    }

    i {
      margin-right: 8px;
      font-size: 15px;
    }

    &-label {
      margin-bottom: 4px;
      color: $gray-slate;
    }
  }

  &__companies {
    $titleHeight: 16px;
    &-title-container {
      position: relative;
      display: flex;
      flex-direction: column;

      &::after {
        content: "";
        position: absolute;
        height: 1px;
        top: 7px;
        left: 0;
        right: 0;
        background-color: $color-grey-border;
      }
    }

    &-title {
      position: relative;
      align-self: flex-start;
      padding-right: 15px;
      z-index: 1;
      @include font-mixin(12px, $titleHeight, 400, $gray-slate, 1.6px, uppercase);
      background-color: $background-white;
    }

    &-item {
      display: flex;
      justify-content: space-between;
      margin-top: 15px;
      @include font-mixin(14px, 18px, 400, $cobalt-black);
    }

    &-item-counter {
      display: flex;
      align-items: center;
      @include font-mixin(18px, 18px, 400, $cobalt-black);

      i {
        margin-left: 7px;
        font-size: 16px;
      }
    }
  }

  &.--state-empty {
    padding: 16px 19px 19px;
  }
}

</style>
